#include <stdio.h>
#include <sys/vfs.h>

unsigned short int fformat = 1;

/* stat the file and print what we find */
void do_statfs(char *filename)
{
	char *formatstr;
    struct statfs statfsbuf;
    statfs(filename, &statfsbuf);
	if (fformat == 0) 
		formatstr = "0x%x %u %u %u %u %u %u %u \n";
	else
		formatstr = "--------\nstatfs:\nFilesystem type: 0x%x\nBlock size: %u\n\
Total blocks: %u\nFree blocks: %u\nFree blocks for non-root: %u\n\
Total inodes: %u\nFree inodes: %u\nMax namelen: %u \n\n";
	printf(formatstr, 
			statfsbuf.f_type,
			statfsbuf.f_bsize,
			statfsbuf.f_blocks,
			statfsbuf.f_bfree,
			statfsbuf.f_bavail,
			statfsbuf.f_files,
			statfsbuf.f_ffree,
			statfsbuf.f_namelen
		);

}

void usage(char *progname)
{
    fprintf(stderr, "Usage: %s [-l] file1 [file2 ...]\n", progname);
    exit(1);
}

int main(int argc, char *argv[])
{
    int c, i = 0;

    while ((c = getopt(argc, argv, "tv")) != EOF) {
		switch (c) {
		case 't':
		    i = 1;
			fformat = 0;
		    break;
		case 'v':
		    printf("stat version: 0.1\n");
		default:
		    usage(argv[0]);
		}
    }
    if (argc == 1)
		usage(argv[0]);
	i++;
    for (; i < argc; i++)
	do_statfs(argv[i]);

    return (0);
}
